/* $Id: com.c,v 1.3 1993/08/22 04:53:48 nils Exp $ */

#include "config.h"
#include "externs.h"

#define IGNORE 	0
#define APPLY	1

static int is_on_channel P((dbref,char *,int));
static int is_on_channel(player, chan, condition)
     dbref player;
     char *chan;
     int condition;
{
  int match;

  if (condition) {
    for (match = 0; match <= db[player].num_channels; match++) {
      if (!strcmp(chan, db[player].channels[match]) &&
          db[player].on[match] == 1)
        return match;
    }
  } else {
    for (match = 0; match <= db[player].num_channels; match++)
      if (!strcmp(chan, db[player].channels[match]))
        return match;
  }

  return -1;
}

extern void com_send (channel, message)
     char *channel;
     char *message;
{
  struct descriptor_data *d;
  for (d = descriptor_list; d; d=d->next)
    if (d->state==CONNECTED && d->player>0 && is_on_channel(d->player, channel, APPLY)>=0) {
      queue_string(d, color(tprintf("%s|NORMAL|", message), ADD));
      queue_string(d, "\n");
    }
}
static void com_who P((dbref, char *));
static void com_who (player, channel)
     dbref player;
     char *channel;
{
  struct descriptor_data *d;
  int hidden = 0;

  for (d = descriptor_list; d; d=d->next)
    if (d->state==CONNECTED && d->player>0 && is_on_channel(d->player, channel, APPLY)>=0) {
      if (could_doit(player, d->player, A_LHIDE))
        notify(player,tprintf("%s is on channel %s.",
			      unparse_object(player,d->player),channel));
      else {
        if (controls(player, d->player, POW_WHO))
          notify(player, tprintf("%s is on channel %s. (HIDDEN)",
                 unparse_object(player,d->player),channel));
        hidden++;
      }
    }

  if (hidden == 0)
    notify(player, "*** There are no hidden users on this channel.");
  else if (hidden == 1)
    notify(player, "*** There is 1 hidden user on this channel.");
  else
    notify(player, tprintf("*** There are %d hidden users on this channel.",
           hidden));
  notify(player,tprintf ("--- %s ---",channel));
}

void do_com(player, arg1, arg2)
     dbref player;
     char *arg1;
     char *arg2;
{
  if (!*arg1) {
    static char buf[1024];
    char *s;
    strcpy(buf,atr_get(player,A_CHANNEL));
    if ((s=strchr(buf,' ')))
      *s = '\0';
    arg1 = buf;
  }
  if (db[player].flags & PLAYER_NO_COM ||
      (db[db[player].owner].flags & PLAYER_NO_COM)) {
    notify(player, "You may not use +com.");
    return;
  }
  if (!*arg1) {
    notify(player,"no channel.");
    return;
  }
  if (strchr(arg1,' ')) {
    notify(player,"you're spacey.");
    return;
  }
  if (!string_compare(arg2,"who"))
    com_who(player,arg1);
  else if (!string_compare(arg2, "off")) {
    int match;
    char buf[2048];

    match = is_on_channel(player, arg1, IGNORE);

    if (match < 0) {
      notify(player, "You're not on that channel.");
      return;
    }

    if (db[player].on[match] == 1) {
      sprintf(buf, "[%s] %s has switched this channel off.", arg1,
              db[player].name);
      com_send(arg1, buf);
      db[player].on[match] = 0;
      notify(player, tprintf("You have switched channel '%s' off.", arg1));
    } else
      notify(player, "That channel is already switched off.");
  } else if (!string_compare(arg2, "on")) {
    int match;
    char buf[2048];

    match = is_on_channel(player, arg1, IGNORE);

    if (match < 0) {
      notify(player, "You're not on that channel.");
      return;
    }

    if (db[player].on[match] == 0) {
      db[player].on[match] = 1;
      sprintf(buf, "[%s] %s has switched this channel on.", arg1,
              db[player].name);
      com_send(arg1, buf);
      notify(player, tprintf("You have switched channel '%s' on.", arg1));
    } else
      notify(player, "That channel is already switched on.");
  } else {
    char buf[2048];
    int channel;

    if (Typeof(player) != TYPE_PLAYER && !power(player,POW_SPOOF)) {
      notify(player,"Non-players can not send +com messages.");
      return;
    }
    
    channel = is_on_channel(player, arg1, APPLY);
   
    if (*arg2 == ':')
      sprintf(buf, "[%s] %s %s", arg1, db[player].name, arg2 + 1);
    else if (*arg2 == ';')
      sprintf(buf, "[%s] %s%s %s", arg1, db[player].name, 
              (arg2[(strlen(arg2) - 1)] == 's') ? "'" : "'s", arg2 + 1);
    else
      if (channel >= 0)
        sprintf(buf, "[%s] %s: %s", arg1, db[player].name, arg2);
    com_send(arg1, buf);
    if (channel < 0)
      notify(player, tprintf("+com message sent to channel '%s'.", arg1));
  }
}

void do_channel(player,arg1,arg2)
     dbref player;
     char *arg1;
     char *arg2;
{
  ptype k;
  char buf[1024];
  int loop;

  if(*arg1 == '\0') {
    if(*atr_get(player,A_CHANNEL))
      notify(player,tprintf("Your default channels is currently '%s'.",
			    atr_get(player,A_CHANNEL)));
    else {
      notify(player,"You don't have a default channel set.");
    }
  } else if(*arg1 == '+') {
    if (db[player].flags & PLAYER_NO_COM ||
        (db[db[player].owner].flags & PLAYER_NO_COM)) {
      notify(player, "You may not add yourself to any channels.");
      return;
    }
      
    arg1++;
    if(Typeof(player)!=TYPE_PLAYER) {
      notify(player,"As of yet, non-players cannot talk on channels.");
      return;
    }
    if (!db[player].pows) return;
    k= *db[player].pows;
    if(*arg1 == '*' &&
       !(k==CLASS_ADMIN ||
	 k==CLASS_DIR)) {
      notify(player,perm_denied());
      return;
    }
    if(*arg1 == '.' &&
       !(k==CLASS_DIR ||
	 k==CLASS_ADMIN ||
	 k==CLASS_BUILDER)) {
      notify(player,perm_denied());
      return;
    }
    if(*arg1 == '_' &&
       !(k==CLASS_DIR ||
	 k==CLASS_ADMIN ||
	 k==CLASS_BUILDER ||
	 k==CLASS_OFFICIAL ||
	 k==CLASS_GUIDE)) {
      notify(player,perm_denied());
      return;
    }
    if (strchr(arg1,' ')) {
      notify(player,"Sorry, channel names can not have spaces in them.");
      return;
    }
    if (!*arg1) {
      notify(player,"What channel?");
      return;
    }
    if (is_on_channel(player,arg1,IGNORE)>=0) {
      notify(player,"You are already on that channel.");
      return;
    }

    db[player].num_channels++;
    if (db[player].num_channels >= db[player].max_channels) {
      char **temp_channels;
      char **temp_aliases;
      int *temp_on;

      db[player].max_channels += 10;

      temp_channels = (char **)malloc(21 * db[player].max_channels);
      temp_aliases = (char **)malloc(21 * db[player].max_channels);
      temp_on = (int *)malloc(sizeof(int) * db[player].max_channels);

      for (loop = 0; loop <= (db[player].num_channels - 1); loop++) {
        temp_channels[loop] = db[player].channels[loop];
        temp_aliases[loop] = db[player].aliases[loop];
        temp_on[loop] = db[player].on[loop];
      }
      free(db[player].channels);
      free(db[player].aliases);
      free(db[player].on);

      db[player].channels = temp_channels;
      db[player].aliases = temp_aliases;
      db[player].on = temp_on;
    }

    db[player].channels[db[player].num_channels] = (char *)malloc(21);
    strncpy(db[player].channels[db[player].num_channels], arg1, 20);
    db[player].channels[db[player].num_channels][21] = (char)NULL;
    db[player].on[db[player].num_channels] = 1;

    if (!*arg2) {
      db[player].aliases[db[player].num_channels] = NULL;
      notify(player,tprintf("'%s' added to your channel list.",arg1));
    } else {
      int match, added = 0;

      for (match = 0; match <= (db[player].num_channels - 1); match++) {
        if (db[player].aliases[match] == NULL)
          continue;
        if (!strcmp(arg2, db[player].aliases[match])) {
          notify(player, tprintf("That alias is used for channel '%s'.",
                 db[player].channels[match]));
          notify(player, "Using no alias for this channel.");
          db[player].aliases[db[player].num_channels] = NULL;
          notify(player,tprintf("'%s' added to your channel list.",arg1));
          added = 1;
          break;
        }
      }

      if (!added) {
        db[player].aliases[db[player].num_channels] = (char *)malloc(21);
        strncpy(db[player].aliases[db[player].num_channels], arg2, 20);
        db[player].aliases[db[player].num_channels][21] = (char)NULL;
        notify(player,tprintf("'%s' added to your channel list with alias '%s'.",
               arg1, arg2));
      }
    }
    sprintf(buf,"[%s] %s has joined this channel.",arg1 , db[player].name);
    com_send(arg1,buf);
  } else if(*arg1 == '-') {
    int i, chan;

    if (db[player].flags & PLAYER_NO_COM ||
        (db[db[player].owner].flags & PLAYER_NO_COM)) {
      notify(player, "You may not remove yourself from any channels.");
      return;
    }

    arg1++;
    
    if (strchr(arg1,' ') || !*arg1) {
      notify(player,"Channels names may not have spaces in them.");
      return;
    }

    i = is_on_channel(player, arg1, IGNORE);

    if (i < 0) {
      notify(player,"You aren't on that channel.");
      return;
    }

    for (i = 0; i <= db[player].num_channels; i++) {
      if (!(strcmp(db[player].channels[i], arg1))) {
        chan = i;
        break;
      } else
        chan = -1;
    }
   
    if (chan > -1) {
      sprintf(buf,"[%s] %s has left this channel.",arg1,db[player].name);
      com_send(arg1,buf);

      free(db[player].channels[chan]);
      free(db[player].aliases[chan]);
      db[player].num_channels--;
      for (i = chan; i <= db[player].num_channels; i++) {
        db[player].channels[i] = db[player].channels[i + 1];
        db[player].aliases[i] = db[player].aliases[i + 1];
        db[player].on[i] = db[player].on[i + 1];
      }
    } else {
      notify(player, "Error - that is not a valid channel.  Why?  Dunno.");
      return; 
    }

    notify(player,tprintf("%s has been deleted from your channel list.",
			  arg1));
  } else {
    if (*arg1) {
      int i;

      i = is_on_channel(player, arg1, IGNORE);
      if (i<0) {
        notify(player,"You aren't on that channel.");
        return;
      }

      atr_add(player, A_CHANNEL, arg1);
      notify(player, tprintf("Your default channel is now '%s'.",arg1));
    } else {
      notify(player,"Usage:");
      notify(player,"  +channel +<channel>    :adds a channel");
      notify(player,"  +channel -<channel>    :deletes a channel");
      notify(player,"  +channel <channel>     :makes <channel> your default");
      notify(player,"  +channel               :lists your channels.");
      notify(player,"For a general chatting channel, try channel 'public'."); 
    }
  }
}
